<?php

namespace Drupal\jsonapi_hypermedia;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Plugin\PluginBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class LinkProviderBase.
 */
abstract class LinkProviderBase extends PluginBase implements LinkProviderInterface, PluginInspectionInterface, ContainerFactoryPluginInterface {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static($configuration, $plugin_id, $plugin_definition);
  }

  /**
   * {@inheritdoc}
   */
  public function getLinkKey() {
    $plugin_definition = $this->getPluginDefinition();
    return $plugin_definition['link_key'];
  }

}
