<?php

namespace Drupal\jsonapi_hypermedia;

/**
 * Interface LinkProviderInterface.
 */
interface LinkProviderInterface {

  /**
   * Gets the link object key for the provided link.
   *
   * @return string
   */
  public function getLinkKey();

  /**
   * Adds, alters or removes hyperlinks from a link collection.
   *
   * @param \Drupal\jsonapi\JsonApiResource\JsonApiDocumentTopLevel|\Drupal\jsonapi\JsonApiResource\ResourceObject $context
   *   The context object from which links should be generated.
   *
   * @return \Drupal\jsonapi\JsonApiResource\Link|\Drupal\jsonapi_hypermedia\AccessRestrictedLink
   *   A link to be added to the context object. An AccessRestrictedLink
   *   should be returned if the link target may be inaccessible to some users.
   */
  public function getLink($context);

}
