<?php

namespace Drupal\jsonapi_hypermedia\Plugin;

use Drupal\Component\Plugin\Discovery\CachedDiscoveryInterface;
use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * Interface LinkProviderManagerInterface
 *
 * @internal
 */
interface LinkProviderManagerInterface extends PluginManagerInterface, CachedDiscoveryInterface {

  /**
   * Gets a LinkCollection of 3rd-party links for the given context object.
   *
   * @param \Drupal\jsonapi\JsonApiResource\JsonApiDocumentTopLevel|\Drupal\jsonapi\JsonApiResource\ResourceObject $context
   *   The link context object.
   *
   * @return \Drupal\jsonapi\JsonApiResource\LinkCollection
   *   The link collection.
   */
  public function getLinkCollection($context);

}
